Index: /palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4345)
+++ /palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4346)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Introduction of wall_flags_total_0, which currently sets bits based on static
+! topography information used in wall_flags_static_0
+! 
+! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
 ! 
@@ -140,5 +144,5 @@
                nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,    &
                topo_top_ind,                                                  &
-               wall_flags_static_0
+               wall_flags_total_0
 
     USE kinds
@@ -925,6 +929,6 @@
              DO  k = nzb_do, nzt_do
                 local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),                &
-                                         REAL( fill_value, KIND = wp ),        &
-                                         BTEST( wall_flags_static_0(k,j,i), flag_nr ) )
+                                  REAL( fill_value, KIND = wp ),               &
+                                  BTEST( wall_flags_total_0(k,j,i), flag_nr ) )
              ENDDO
           ENDDO
@@ -1022,5 +1026,5 @@
                                    to_be_resorted(k,j,i),                &
                                    REAL( fill_value, KIND = wp ),        &
-                                   BTEST( wall_flags_static_0(k,j,i), flag_nr ) )
+                                   BTEST( wall_flags_total_0(k,j,i), flag_nr ) )
              ENDDO
           ENDDO
@@ -1311,5 +1315,5 @@
                 DO  k = nzb, nzt
                    e(k,j,i)     = MERGE( e(k,j,i), 0.0_wp,                     &
-                                         BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                                         BTEST( wall_flags_total_0(k,j,i), 0 ) )
                 ENDDO
              ENDDO
@@ -1321,5 +1325,5 @@
                    DO  k = nzb, nzt
                       diss(k,j,i)    = MERGE( diss(k,j,i), 0.0_wp,             &
-                                              BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                                         BTEST( wall_flags_total_0(k,j,i), 0 ) )
                    ENDDO
                 ENDDO
@@ -1367,5 +1371,5 @@
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb,  &
-               nzt, wall_flags_static_0
+               nzt, wall_flags_total_0
 
     USE kinds
@@ -1441,77 +1445,77 @@
 !
 !--                Check if current gridpoint belongs to the atmosphere
-                   IF ( BTEST( wall_flags_static_0(k,j,i), 0 ) )  THEN
+                   IF ( BTEST( wall_flags_total_0(k,j,i), 0 ) )  THEN
 !
 !--                   Check for neighbouring grid-points.
 !--                   Vertical distance, down
-                      IF ( .NOT. BTEST( wall_flags_static_0(k-1,j,i), 0 ) )             &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k-1,j,i), 0 ) )             &
                          l_wall(k,j,i) = MIN( l_grid(k), zu(k) - zw(k-1) )
 !
 !--                   Vertical distance, up
-                      IF ( .NOT. BTEST( wall_flags_static_0(k+1,j,i), 0 ) )             &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k+1,j,i), 0 ) )             &
                          l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), zw(k) - zu(k) )
 !
 !--                   y-distance
-                      IF ( .NOT. BTEST( wall_flags_static_0(k,j-1,i), 0 )  .OR.         &
-                           .NOT. BTEST( wall_flags_static_0(k,j+1,i), 0 ) )             &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k,j-1,i), 0 )  .OR.         &
+                           .NOT. BTEST( wall_flags_total_0(k,j+1,i), 0 ) )             &
                          l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), 0.5_wp * dy )
 !
 !--                   x-distance
-                      IF ( .NOT. BTEST( wall_flags_static_0(k,j,i-1), 0 )  .OR.         &
-                           .NOT. BTEST( wall_flags_static_0(k,j,i+1), 0 ) )             &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k,j,i-1), 0 )  .OR.         &
+                           .NOT. BTEST( wall_flags_total_0(k,j,i+1), 0 ) )             &
                          l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k), 0.5_wp * dx )
 !
 !--                   yz-distance (vertical edges, down)
-                      IF ( .NOT. BTEST( wall_flags_static_0(k-1,j-1,i), 0 )  .OR.       &
-                           .NOT. BTEST( wall_flags_static_0(k-1,j+1,i), 0 )  )          &
-                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),          &
-                                              SQRT( 0.25_wp * dy**2 +            &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k-1,j-1,i), 0 )  .OR.       &
+                           .NOT. BTEST( wall_flags_total_0(k-1,j+1,i), 0 )  )          &
+                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),                &
+                                              SQRT( 0.25_wp * dy**2 +                  &
                                              ( zu(k) - zw(k-1) )**2 ) )
 !
 !--                   yz-distance (vertical edges, up)
-                      IF ( .NOT. BTEST( wall_flags_static_0(k+1,j-1,i), 0 )  .OR.       &
-                           .NOT. BTEST( wall_flags_static_0(k+1,j+1,i), 0 )  )          &
-                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),          &
-                                              SQRT( 0.25_wp * dy**2 +            &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k+1,j-1,i), 0 )  .OR.       &
+                           .NOT. BTEST( wall_flags_total_0(k+1,j+1,i), 0 )  )          &
+                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),                &
+                                              SQRT( 0.25_wp * dy**2 +                  &
                                              ( zw(k) - zu(k) )**2 ) )
 !
 !--                   xz-distance (vertical edges, down)
-                      IF ( .NOT. BTEST( wall_flags_static_0(k-1,j,i-1), 0 )  .OR.       &
-                           .NOT. BTEST( wall_flags_static_0(k-1,j,i+1), 0 )  )          &
-                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),          &
-                                              SQRT( 0.25_wp * dx**2 +            &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k-1,j,i-1), 0 )  .OR.       &
+                           .NOT. BTEST( wall_flags_total_0(k-1,j,i+1), 0 )  )          &
+                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),                &
+                                              SQRT( 0.25_wp * dx**2 +                  &
                                              ( zu(k) - zw(k-1) )**2 ) )
 !
 !--                   xz-distance (vertical edges, up)
-                      IF ( .NOT. BTEST( wall_flags_static_0(k+1,j,i-1), 0 )  .OR.       &
-                           .NOT. BTEST( wall_flags_static_0(k+1,j,i+1), 0 )  )          &
-                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),          &
-                                              SQRT( 0.25_wp * dx**2 +            &
-                                             ( zw(k) - zu(k) )**2 ) )
+                      IF ( .NOT. BTEST( wall_flags_total_0(k+1,j,i-1), 0 )  .OR.       &
+                           .NOT. BTEST( wall_flags_total_0(k+1,j,i+1), 0 )  )          &
+                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),                &
+                                              SQRT( 0.25_wp * dx**2 +                  &
+                                             ( zw(k) - zu(k) )**2 ) )                 
 !
 !--                   xy-distance (horizontal edges)
-                      IF ( .NOT. BTEST( wall_flags_static_0(k,j-1,i-1), 0 )  .OR.        &
-                           .NOT. BTEST( wall_flags_static_0(k,j+1,i-1), 0 )  .OR.        &
-                           .NOT. BTEST( wall_flags_static_0(k,j-1,i+1), 0 )  .OR.        &
-                           .NOT. BTEST( wall_flags_static_0(k,j+1,i+1), 0 ) )            &
-                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),           &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k,j-1,i-1), 0 )  .OR.        &
+                           .NOT. BTEST( wall_flags_total_0(k,j+1,i-1), 0 )  .OR.        &
+                           .NOT. BTEST( wall_flags_total_0(k,j-1,i+1), 0 )  .OR.        &
+                           .NOT. BTEST( wall_flags_total_0(k,j+1,i+1), 0 ) )            &
+                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),                 &
                                               SQRT( 0.25_wp * ( dx**2 + dy**2 ) ) )
 !
 !--                   xyz distance (vertical and horizontal edges, down)
-                      IF ( .NOT. BTEST( wall_flags_static_0(k-1,j-1,i-1), 0 )  .OR.      &
-                           .NOT. BTEST( wall_flags_static_0(k-1,j+1,i-1), 0 )  .OR.      &
-                           .NOT. BTEST( wall_flags_static_0(k-1,j-1,i+1), 0 )  .OR.      &
-                           .NOT. BTEST( wall_flags_static_0(k-1,j+1,i+1), 0 ) )          &
-                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),           &
-                                              SQRT( 0.25_wp * ( dx**2 + dy**2 )   &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k-1,j-1,i-1), 0 )  .OR.      &
+                           .NOT. BTEST( wall_flags_total_0(k-1,j+1,i-1), 0 )  .OR.      &
+                           .NOT. BTEST( wall_flags_total_0(k-1,j-1,i+1), 0 )  .OR.      &
+                           .NOT. BTEST( wall_flags_total_0(k-1,j+1,i+1), 0 ) )          &
+                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),                 &
+                                              SQRT( 0.25_wp * ( dx**2 + dy**2 )         &
                                                     +  ( zu(k) - zw(k-1) )**2  ) )
 !
 !--                   xyz distance (vertical and horizontal edges, up)
-                      IF ( .NOT. BTEST( wall_flags_static_0(k+1,j-1,i-1), 0 )  .OR.      &
-                           .NOT. BTEST( wall_flags_static_0(k+1,j+1,i-1), 0 )  .OR.      &
-                           .NOT. BTEST( wall_flags_static_0(k+1,j-1,i+1), 0 )  .OR.      &
-                           .NOT. BTEST( wall_flags_static_0(k+1,j+1,i+1), 0 ) )          &
-                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),           &
-                                              SQRT( 0.25_wp * ( dx**2 + dy**2 )   &
+                      IF ( .NOT. BTEST( wall_flags_total_0(k+1,j-1,i-1), 0 )  .OR.      &
+                           .NOT. BTEST( wall_flags_total_0(k+1,j+1,i-1), 0 )  .OR.      &
+                           .NOT. BTEST( wall_flags_total_0(k+1,j-1,i+1), 0 )  .OR.      &
+                           .NOT. BTEST( wall_flags_total_0(k+1,j+1,i+1), 0 ) )          &
+                         l_wall(k,j,i) = MIN( l_wall(k,j,i), l_grid(k),                 &
+                                              SQRT( 0.25_wp * ( dx**2 + dy**2 )         &
                                                     +  ( zw(k) - zu(k) )**2  ) )
 
@@ -1553,5 +1557,5 @@
           DO  j = nysg, nyng
              DO  k = nzb+1, nzt-1
-                IF ( .NOT. BTEST( wall_flags_static_0(k,j,i), 0 ) .AND.  &
+                IF ( .NOT. BTEST( wall_flags_total_0(k,j,i), 0 ) .AND.  &
                      k > k_max_topo )  &
                    k_max_topo = k
@@ -1619,5 +1623,5 @@
 !
 !--                Start search only if (i/j/k) belongs to atmosphere
-                   IF ( BTEST( wall_flags_static_0(k,j,i), 0 )  )  THEN
+                   IF ( BTEST( wall_flags_total_0(k,j,i), 0 )  )  THEN
 !
 !--                   Reset topography within vicinity
@@ -1839,5 +1843,5 @@
 ! ------------
 !> Copy a subarray of size (kb:kt,js:jn,il:ir) centered around grid point
-!> (kp,jp,ip) containing the first bit of wall_flags_static_0 into the array
+!> (kp,jp,ip) containing the first bit of wall_flags_total_0 into the array
 !> 'vicinity'. Only copy first bit as this indicates the presence of topography.
 !------------------------------------------------------------------------------!
@@ -1864,5 +1868,5 @@
              DO  k = kb, kt
                 vicinity(k,j,i) = MERGE( 0, 1,               &
-                       BTEST( wall_flags_static_0(kp+k,jp+j,ip+i), 0 ) )
+                       BTEST( wall_flags_total_0(kp+k,jp+j,ip+i), 0 ) )
              ENDDO
           ENDDO
@@ -2263,5 +2267,5 @@
 !--    value is reduced by 90%.
        !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC PRESENT(e, tend, te_m, wall_flags_static_0) &
+       !$ACC PRESENT(e, tend, te_m, wall_flags_total_0) &
        !$ACC PRESENT(tsc(3:3)) &
        !$ACC PRESENT(e_p)
@@ -2273,5 +2277,5 @@
                                         )                                      &
                                    * MERGE( 1.0_wp, 0.0_wp,                    &
-                                             BTEST( wall_flags_static_0(k,j,i), 0 )   &
+                                       BTEST( wall_flags_total_0(k,j,i), 0 )   &
                                           )
                 IF ( e_p(k,j,i) < 0.0_wp )  e_p(k,j,i) = 0.1_wp * e(k,j,i)
@@ -2380,5 +2384,5 @@
                                         )                                      &
                                    * MERGE( 1.0_wp, 0.0_wp,                    &
-                                             BTEST( wall_flags_static_0(k,j,i), 0 )   &
+                                       BTEST( wall_flags_total_0(k,j,i), 0 )   &
                                           )
                 IF ( diss_p(k,j,i) < 0.0_wp )                                  &
@@ -2495,5 +2499,5 @@
                                   )                                            &
                                  * MERGE( 1.0_wp, 0.0_wp,                      &
-                                          BTEST( wall_flags_static_0(k,j,i), 0 )      &
+                                    BTEST( wall_flags_total_0(k,j,i), 0 )      &
                                         )
           IF ( e_p(k,j,i) <= 0.0_wp )  e_p(k,j,i) = 0.1_wp * e(k,j,i)
@@ -2562,5 +2566,5 @@
                                         )                                      &
                                         * MERGE( 1.0_wp, 0.0_wp,               &
-                                                BTEST( wall_flags_static_0(k,j,i), 0 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
                                                )
        ENDDO
@@ -2657,5 +2661,5 @@
     !$ACC PRIVATE(surf_s, surf_e) &
     !$ACC PRIVATE(dudx(:), dudy(:), dudz(:), dvdx(:), dvdy(:), dvdz(:), dwdx(:), dwdy(:), dwdz(:)) &
-    !$ACC PRESENT(e, u, v, w, diss, dd2zu, ddzw, km, wall_flags_static_0) &
+    !$ACC PRESENT(e, u, v, w, diss, dd2zu, ddzw, km, wall_flags_total_0) &
     !$ACC PRESENT(tend) &
     !$ACC PRESENT(surf_def_h(0:1), surf_def_v(0:3)) &
@@ -2717,5 +2721,5 @@
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
                    sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                                     BTEST( wall_flags_static_0(k,j-1,i), flag_nr ) )
+                              BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
                    dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
                    dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -2736,5 +2740,5 @@
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
                    sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                                     BTEST( wall_flags_static_0(k,j-1,i), flag_nr ) )
+                              BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
                    dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
                    dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -2755,5 +2759,5 @@
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
                    sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                                     BTEST( wall_flags_static_0(k,j-1,i), flag_nr ) )
+                              BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
                    dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
                    dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -2776,5 +2780,5 @@
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
                    sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                                     BTEST( wall_flags_static_0(k,j,i-1), flag_nr ) )
+                              BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
                    dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
                    dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -2795,5 +2799,5 @@
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
                    sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                                     BTEST( wall_flags_static_0(k,j,i-1), flag_nr ) )
+                              BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
                    dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
                    dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -2814,5 +2818,5 @@
 !--                -1.0 for right-facing wall, 1.0 for left-facing wall
                    sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                                     BTEST( wall_flags_static_0(k,j,i-1), flag_nr ) )
+                              BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
                    dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
                    dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -2889,5 +2893,5 @@
              IF ( def < 0.0_wp )  def = 0.0_wp
 
-             flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),flag_nr) )
+             flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),flag_nr) )
 
              IF ( .NOT. diss_production )  THEN
@@ -2953,5 +2957,5 @@
 !--                   Compute tendency for TKE-production from shear
                       DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                          tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                        MERGE( rho_reference, prho(k,j,i),       &
@@ -2963,5 +2967,5 @@
 !--                   RANS mode: Compute tendency for dissipation-rate-production from shear
                       DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                          tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                        MERGE( rho_reference, prho(k,j,i),       &
@@ -2981,5 +2985,5 @@
              !$ACC PRIVATE(surf_s, surf_e) &
              !$ACC PRIVATE(tmp_flux(nzb+1:nzt)) &
-             !$ACC PRESENT(e, diss, kh, pt, dd2zu, drho_air_zw, wall_flags_static_0) &
+             !$ACC PRESENT(e, diss, kh, pt, dd2zu, drho_air_zw, wall_flags_total_0) &
              !$ACC PRESENT(tend) &
              !$ACC PRESENT(surf_def_h(0:2)) &
@@ -3041,5 +3045,5 @@
                      !$ACC LOOP PRIVATE(k, flag)
                       DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                          tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                        MERGE( pt_reference, pt(k,j,i),          &
@@ -3051,5 +3055,5 @@
 !--                   RANS mode: Compute tendency for dissipation-rate-production from shear
                       DO  k = nzb+1, nzt
-                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                         flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                          tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                        MERGE( pt_reference, pt(k,j,i),          &
@@ -3256,5 +3260,5 @@
 !--                Compute tendency for TKE-production from shear
                    DO  k = nzb+1, nzt
-                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                       tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                     MERGE( vpt_reference, vpt(k,j,i),          &
@@ -3266,5 +3270,5 @@
 !--                RANS mode: Compute tendency for dissipation-rate-production from shear
                    DO  k = nzb+1, nzt
-                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                      flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                       tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g /   &
                                     MERGE( vpt_reference, vpt(k,j,i),          &
@@ -3401,5 +3405,5 @@
 !--          -1.0 for right-facing wall, 1.0 for left-facing wall
              sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                               BTEST( wall_flags_static_0(k,j-1,i), flag_nr ) )
+                        BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
              dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
              dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -3419,5 +3423,5 @@
 !--          -1.0 for right-facing wall, 1.0 for left-facing wall
              sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                               BTEST( wall_flags_static_0(k,j-1,i), flag_nr ) )
+                        BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
              dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
              dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -3437,5 +3441,5 @@
 !--          -1.0 for right-facing wall, 1.0 for left-facing wall
              sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                               BTEST( wall_flags_static_0(k,j-1,i), flag_nr ) )
+                        BTEST( wall_flags_total_0(k,j-1,i), flag_nr ) )
              dudy(k) = sign_dir * usvs / ( km_neutral + 1E-10_wp )
              dwdy(k) = sign_dir * wsvs / ( km_neutral + 1E-10_wp )
@@ -3457,5 +3461,5 @@
 !--          -1.0 for right-facing wall, 1.0 for left-facing wall
              sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                               BTEST( wall_flags_static_0(k,j,i-1), flag_nr ) )
+                        BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
              dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
              dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -3475,5 +3479,5 @@
 !--          -1.0 for right-facing wall, 1.0 for left-facing wall
              sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                               BTEST( wall_flags_static_0(k,j,i-1), flag_nr ) )
+                        BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
              dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
              dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -3493,5 +3497,5 @@
 !--          -1.0 for right-facing wall, 1.0 for left-facing wall
              sign_dir = MERGE( 1.0_wp, -1.0_wp,                          &
-                               BTEST( wall_flags_static_0(k,j,i-1), flag_nr ) )
+                        BTEST( wall_flags_total_0(k,j,i-1), flag_nr ) )
              dvdx(k) = sign_dir * vsus / ( km_neutral + 1E-10_wp )
              dwdx(k) = sign_dir * wsus / ( km_neutral + 1E-10_wp )
@@ -3561,5 +3565,5 @@
        IF ( def < 0.0_wp )  def = 0.0_wp
 
-       flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),flag_nr) )
+       flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),flag_nr) )
 
        IF ( .NOT. diss_production )  THEN
@@ -3618,5 +3622,5 @@
 !--             Compute tendency for TKE-production from shear
                 DO  k = nzb+1, nzt
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                    tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                  MERGE( rho_reference, prho(k,j,i),       &
@@ -3628,5 +3632,5 @@
 !--             RANS mode: Compute tendency for dissipation-rate-production from shear
                 DO  k = nzb+1, nzt
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                    tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                  MERGE( rho_reference, prho(k,j,i),       &
@@ -3687,5 +3691,5 @@
 !--             Compute tendency for TKE-production from shear
                 DO  k = nzb+1, nzt
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                    tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                  MERGE( pt_reference, pt(k,j,i),          &
@@ -3697,5 +3701,5 @@
 !--             RANS mode: Compute tendency for dissipation-rate-production from shear
                 DO  k = nzb+1, nzt
-                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                   flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                    tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                                  MERGE( pt_reference, pt(k,j,i),          &
@@ -3896,5 +3900,5 @@
 !--          Compute tendency for TKE-production from shear
              DO  k = nzb+1, nzt
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                 tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g / &
                               MERGE( vpt_reference, vpt(k,j,i),          &
@@ -3906,5 +3910,5 @@
 !--          RANS mode: Compute tendency for dissipation-rate-production from shear
              DO  k = nzb+1, nzt
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_static_0(k,j,i),0) )
+                flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_total_0(k,j,i),0) )
                 tend(k,j,i) = tend(k,j,i) + flag * tmp_flux(k) * ( g /   &
                               MERGE( vpt_reference, vpt(k,j,i),          &
@@ -3972,5 +3976,5 @@
        !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j) &
        !$ACC PRIVATE(l, l_stable, dvar_dz) &
-       !$ACC PRESENT(diss, e, var, wall_flags_static_0) &
+       !$ACC PRESENT(diss, e, var, wall_flags_total_0) &
        !$ACC PRESENT(dd2zu, l_grid, l_wall)
        DO  i = nxl, nxr
@@ -4002,5 +4006,5 @@
                 diss(k,j,i) = ( 0.19_wp + 0.74_wp * l / l_wall(k,j,i) )                &
                               * e(k,j,i) * SQRT( e(k,j,i) ) / l                        &
-                              * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                              * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 
              ENDDO
@@ -4013,5 +4017,5 @@
       !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j) &
       !$ACC PRIVATE(l_stable, duv2_dz2, rif, dvar_dz) &
-      !$ACC PRESENT(diss, e, u, v, var, wall_flags_static_0) &
+      !$ACC PRESENT(diss, e, u, v, var, wall_flags_total_0) &
       !$ACC PRESENT(dd2zu, l_black, l_wall)
        DO  i = nxl, nxr
@@ -4060,5 +4064,5 @@
 
                 diss(k,j,i) = c_0**3 * e(k,j,i) * SQRT( e(k,j,i) ) / l_stable(k)     &
-                            * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                            * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 
              ENDDO
@@ -4072,5 +4076,5 @@
 
     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-    !$ACC PRESENT(diss, e, km, tend, wall_flags_static_0) &
+    !$ACC PRESENT(diss, e, km, tend, wall_flags_total_0) &
     !$ACC PRESENT(ddzu, ddzw, rho_air_zw, drho_air)
     DO  i = nxl, nxr
@@ -4095,5 +4099,5 @@
                                          ) * dsig_e                                   &
                                            * MERGE( 1.0_wp, 0.0_wp,                   &
-                                                    BTEST( wall_flags_static_0(k,j,i), 0 ) ) &
+                                             BTEST( wall_flags_total_0(k,j,i), 0 ) )  &
                           - diss(k,j,i)
 
@@ -4201,5 +4205,5 @@
           diss(k,j,i) = ( 0.19_wp + 0.74_wp * l / l_wall(k,j,i) )              &
                         * e(k,j,i) * SQRT( e(k,j,i) ) / l                      &
-                        * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                        * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
        ENDDO
 
@@ -4245,5 +4249,5 @@
        DO  k = nzb+1, nzt
           diss(k,j,i) = c_0**3 * e(k,j,i) * SQRT( e(k,j,i) ) / l_stable(k)     &
-                      * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                      * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
        ENDDO
 
@@ -4274,5 +4278,5 @@
                                    ) * dsig_e                                  &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 0 ) )&
+                                        BTEST( wall_flags_total_0(k,j,i), 0 ) )&
                                  - diss(k,j,i)
 
@@ -4337,5 +4341,5 @@
 !
 !--          Predetermine flag to mask topography
-             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+             flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 
              tend(k,j,i) = tend(k,j,i) +                                       &
@@ -4393,5 +4397,5 @@
 !
 !--    Predetermine flag to mask topography
-       flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+       flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
 
 !
@@ -4454,5 +4458,5 @@
              DO  k = nzb+1, nzt
                 e(k,j,i) = MAX( e(k,j,i), e_min ) *                            &
-                        MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 0 ) )
+                        MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 0 ) )
              ENDDO
           ENDDO
